package com.mortals.xhx.module.member.model;

import java.util.Date;
import com.mortals.framework.model.BaseEntityLong;
/**
*
* Description:Member
* date: 2021-9-1 14:27:26
*/
public class MemberEntity extends BaseEntityLong{
    private static final long serialVersionUID = 1630477646904L;


    /**
    * 手机号
    */
    private String phone;

    /**
    * unionid，同一个微信开放平台的唯一标识
    */
    private String unionid;

    /**
    * 微信openId
    */
    private String openId;

    /**
    * 头像地址
    */
    private String picImage;

    /**
    * 昵称
    */
    private String nickname;

    /**
    * 真实姓名
    */
    private String realName;

    /**
    * 1：男，2：女
    */
    private String gender;

    /**
    * 最后登录时间
    */
    private Date lastLoginTime;

    /**
    * 备注
    */
    private String remark;

    /**
    * 用户状态，0:正常，1:禁用,默认0
    */
    private Integer status;

    /**
    * 创建时间
    */
    private Date createTime;

    /**
    * 创建用户
    */
    private String createUser;

    /**
    * 创建用户名称
    */
    private String createUserName;

    public MemberEntity(){

    }
    /**
    * 获取 手机号
    * @return phone
    */
    public String getPhone() {
        return this.phone;
    }
    /**
    * 设置 手机号
    * @param phone
    */
    public void setPhone(String phone) {
        this.phone = phone;
    }
    /**
    * 获取 unionid，同一个微信开放平台的唯一标识
    * @return unionid
    */
    public String getUnionid() {
        return this.unionid;
    }
    /**
    * 设置 unionid，同一个微信开放平台的唯一标识
    * @param unionid
    */
    public void setUnionid(String unionid) {
        this.unionid = unionid;
    }
    /**
    * 获取 微信openId
    * @return openId
    */
    public String getOpenId() {
        return this.openId;
    }
    /**
    * 设置 微信openId
    * @param openId
    */
    public void setOpenId(String openId) {
        this.openId = openId;
    }
    /**
    * 获取 头像地址
    * @return picImage
    */
    public String getPicImage() {
        return this.picImage;
    }
    /**
    * 设置 头像地址
    * @param picImage
    */
    public void setPicImage(String picImage) {
        this.picImage = picImage;
    }
    /**
    * 获取 昵称
    * @return nickname
    */
    public String getNickname() {
        return this.nickname;
    }
    /**
    * 设置 昵称
    * @param nickname
    */
    public void setNickname(String nickname) {
        this.nickname = nickname;
    }
    /**
    * 获取 真实姓名
    * @return realName
    */
    public String getRealName() {
        return this.realName;
    }
    /**
    * 设置 真实姓名
    * @param realName
    */
    public void setRealName(String realName) {
        this.realName = realName;
    }
    /**
    * 获取 1：男，2：女
    * @return gender
    */
    public String getGender() {
        return this.gender;
    }
    /**
    * 设置 1：男，2：女
    * @param gender
    */
    public void setGender(String gender) {
        this.gender = gender;
    }
    /**
    * 获取 最后登录时间
    * @return lastLoginTime
    */
    public Date getLastLoginTime() {
        return this.lastLoginTime;
    }
    /**
    * 设置 最后登录时间
    * @param lastLoginTime
    */
    public void setLastLoginTime(Date lastLoginTime) {
        this.lastLoginTime = lastLoginTime;
    }
    /**
    * 获取 备注
    * @return remark
    */
    public String getRemark() {
        return this.remark;
    }
    /**
    * 设置 备注
    * @param remark
    */
    public void setRemark(String remark) {
        this.remark = remark;
    }
    /**
    * 获取 用户状态，0:正常，1:禁用,默认0
    * @return status
    */
    public Integer getStatus() {
        return this.status;
    }
    /**
    * 设置 用户状态，0:正常，1:禁用,默认0
    * @param status
    */
    public void setStatus(Integer status) {
        this.status = status;
    }
    /**
    * 获取 创建时间
    * @return createTime
    */
    public Date getCreateTime() {
        return this.createTime;
    }
    /**
    * 设置 创建时间
    * @param createTime
    */
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }
    /**
    * 获取 创建用户
    * @return createUser
    */
    public String getCreateUser() {
        return this.createUser;
    }
    /**
    * 设置 创建用户
    * @param createUser
    */
    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }
    /**
    * 获取 创建用户名称
    * @return createUserName
    */
    public String getCreateUserName() {
        return this.createUserName;
    }
    /**
    * 设置 创建用户名称
    * @param createUserName
    */
    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }

    @Override
    public int hashCode() {
        return this.getId().hashCode();
    }
    @Override
    public boolean equals(Object obj) {
        if (obj == null)
            return false;
        if (obj instanceof MemberEntity) {
            MemberEntity tmp = (MemberEntity) obj;
            if (this.getId().longValue() == tmp.getId().longValue()) {
                return true;
            }
        }
        return false;
    }

    public String toString(){
        StringBuilder sb = new StringBuilder("");
        sb
        .append(",id:").append(getId())
                .append(",phone:").append(getPhone())
                .append(",unionid:").append(getUnionid())
                .append(",openId:").append(getOpenId())
                .append(",picImage:").append(getPicImage())
                .append(",nickname:").append(getNickname())
                .append(",realName:").append(getRealName())
                .append(",gender:").append(getGender())
                .append(",lastLoginTime:").append(getLastLoginTime())
                .append(",remark:").append(getRemark())
                .append(",status:").append(getStatus())
                .append(",createTime:").append(getCreateTime())
                .append(",createUser:").append(getCreateUser())
                .append(",createUserName:").append(getCreateUserName())
        ;
        return sb.toString();
    }

    public void initAttrValue(){
         this.phone = null;

         this.unionid = null;

         this.openId = null;

         this.picImage = null;

         this.nickname = null;

         this.realName = null;

         this.gender = null;

         this.lastLoginTime = null;

         this.remark = null;

         this.status = null;

         this.createTime = null;

         this.createUser = null;

         this.createUserName = null;

    }
}