package com.mortals.xhx.module.member.service.impl;

import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.xhx.common.code.YesNoEnum;
import org.springframework.stereotype.Service;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.xhx.module.member.dao.MemberDao;
import com.mortals.xhx.module.member.model.MemberEntity;
import com.mortals.xhx.module.member.service.MemberService;

/**
* <p>Title: 微信会员基本信息</p>
* <p>Description: MemberService service接口 </p>
* <p>Copyright: Copyright &reg;  </p>
* @version 1.0.0
*/
@Service("memberService")
public class MemberServiceImpl extends AbstractCRUDServiceImpl<MemberDao, MemberEntity, Long> implements MemberService {


    @Override
    protected void saveBefore(MemberEntity entity, Context context) throws AppException {

        entity.setStatus(YesNoEnum.YES.getValue());
        entity.setGender("男");
        super.saveBefore(entity, context);
    }
}