package com.mortals.xhx.module.onething.web;

import com.mortals.framework.model.Context;
import com.mortals.xhx.common.code.ApproveStateEnum;
import com.mortals.xhx.common.code.UserStatus;
import com.mortals.xhx.common.code.YesNoEnum;
import com.mortals.xhx.module.member.web.MemberForm;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.mortals.framework.web.BaseCRUDJsonMappingController;
import com.mortals.xhx.module.onething.model.OnethingEntity;
import com.mortals.xhx.module.onething.service.OnethingService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Map;


/**
* <p>Title: 一件事提交基础表</p>
* <p>Description: OnethingController  </p>
* <p>Copyright: Copyright &reg;  </p>
* <p>Company: </p>
* @author zxfei
* @version 1.0.0
*/
@RestController
@RequestMapping("onething")
public class OnethingController extends BaseCRUDJsonMappingController<OnethingService,OnethingForm,OnethingEntity,Long> {

    public OnethingController(){
        super.setFormClass(OnethingForm.class);
        super.setModuleDesc("一件事提交基础表");
    }


    @Override
    protected void init(HttpServletRequest request, HttpServletResponse response, OnethingForm form, Map<String, Object> model, Context context) {
        this.addDict(model, "status", ApproveStateEnum.getEnumMap());
        this.addDict(model, "isRevoke", YesNoEnum.getEnumMap());
    }
}